#ifndef MAP_H
#define MAP_H

#include "expr.h"	/* for 'struct Expr' */
#include "symbol.h"	/* for 'struct Align, Map, Symbol' */
#include "typedef.h"	/* for 'bool' */

/*{{{  #defines*/
/*---------------------------------------------------------------*/
/* Flags for 'result_flags' parameter of 'attain_mapping (ep,..)'*/
/*---------------------------------------------------------------*/
#define  RESULT_VAR		0x1	/* On return 'ep' must be a
					    variable, not a general expr */
#define  RESULT_MAPVEC		0x2	/* On return 'ep' must have a 'mapvec'
					    (unless its a global scalar). Only
					    set together with 'RESULT_VAR' */
#define  COPY_BACK_IF_VAR	0x4	/* If 'ep' is replaced by a temporary
					     var, set ptr in it to original
					     'ep' for subsequent copy-back */

/*-----------------*/
/* composite flags */
/*-----------------*/
#define  RESULT_VAR_AND_MAPVEC	(RESULT_VAR | RESULT_MAPVEC)


/*------------------------------------------------------*/
/* '_ARGLIST' values for 'arglist_type' parameter of	*/
/* 'transform_and_write_IO_stmt ()'			*/
/*------------------------------------------------------*/
#define  IO_ARGLIST		1
#define  OPEN_ARGLIST		2
#define  CLOSE_ARGLIST		3
#define  FILEPOS_ARGLIST	4
#define  INQUIRE_ARGLIST	5
/*}}}*/
/*{{{  externs*/
/*------------------*/
/*  function decls  */
/*------------------*/
bool   is_distrib ();
int    proc_dim ();
Expr  *attain_mapping (),  *broadcast_expr (),  *collapse_expr_on_p0 (),
      *ncycles (),   *seg_extent (),  *seg_totlen ();
Map   *equiv_scalar_map (),  *scalar_map_on_p0 ();
Sect  *whole_object_sect ();

/*-----------*/
/*  globals  */
/*-----------*/
extern Align	*inherit_alignp;
extern Map	*inherit_mapp,  *scalar_on_p0_mapp;
extern Symbol	*default_proc_sp [MAX_RANK + 1];
/*}}}*/
/*{{{  macros*/
#define  broadcast_scalar(ep)	attain_mapping((ep), NULL_Map, NULL_Sect, 0)
/*}}}*/

#endif
